/* valainitializerlist.c generated by valac, the Vala compiler
 * generated from valainitializerlist.vala, do not modify */

/* valainitializerlist.vala
 *
 * Copyright (C) 2006-2011  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * 	Raffaele Sandrini <raffaele@sandrini.ch>
 */


#include <glib.h>
#include <glib-object.h>
#include "vala.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))

struct _ValaInitializerListPrivate {
	ValaList* initializers;
};


static gpointer vala_initializer_list_parent_class = NULL;

#define VALA_INITIALIZER_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_INITIALIZER_LIST, ValaInitializerListPrivate))
static void vala_initializer_list_real_accept_children (ValaCodeNode* base,
                                                 ValaCodeVisitor* visitor);
static void vala_initializer_list_real_accept (ValaCodeNode* base,
                                        ValaCodeVisitor* visitor);
static gboolean vala_initializer_list_real_is_constant (ValaExpression* base);
static gboolean vala_initializer_list_real_is_pure (ValaExpression* base);
static gboolean vala_initializer_list_real_is_accessible (ValaExpression* base,
                                                   ValaSymbol* sym);
static gchar* vala_initializer_list_real_to_string (ValaCodeNode* base);
static void vala_initializer_list_real_replace_expression (ValaCodeNode* base,
                                                    ValaExpression* old_node,
                                                    ValaExpression* new_node);
static gboolean vala_initializer_list_real_check (ValaCodeNode* base,
                                           ValaCodeContext* context);
static void vala_initializer_list_real_emit (ValaCodeNode* base,
                                      ValaCodeGenerator* codegen);
static void vala_initializer_list_real_get_used_variables (ValaCodeNode* base,
                                                    ValaCollection* collection);
static void vala_initializer_list_finalize (ValaCodeNode * obj);


/**
 * Appends the specified expression to this initializer 
 *
 * @param expr an expression
 */
void
vala_initializer_list_append (ValaInitializerList* self,
                              ValaExpression* expr)
{
	ValaList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->initializers;
	vala_collection_add ((ValaCollection*) _tmp0_, expr);
	vala_code_node_set_parent_node ((ValaCodeNode*) expr, (ValaCodeNode*) self);
}


/**
 * Returns a copy of the expression 
 *
 * @return expression list
 */
static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


ValaList*
vala_initializer_list_get_initializers (ValaInitializerList* self)
{
	ValaList* result = NULL;
	ValaList* _tmp0_;
	ValaList* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->initializers;
	_tmp1_ = _vala_iterable_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Creates a new initializer 
 *
 * @param source_reference reference to source code
 * @return                 newly created initializer list
 */
ValaInitializerList*
vala_initializer_list_construct (GType object_type,
                                 ValaSourceReference* source_reference)
{
	ValaInitializerList* self = NULL;
	g_return_val_if_fail (source_reference != NULL, NULL);
	self = (ValaInitializerList*) vala_expression_construct (object_type);
	vala_code_node_set_source_reference ((ValaCodeNode*) self, source_reference);
	return self;
}


ValaInitializerList*
vala_initializer_list_new (ValaSourceReference* source_reference)
{
	return vala_initializer_list_construct (VALA_TYPE_INITIALIZER_LIST, source_reference);
}


static void
vala_initializer_list_real_accept_children (ValaCodeNode* base,
                                            ValaCodeVisitor* visitor)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (visitor != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaExpression* expr = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaExpression* _tmp11_;
			_tmp5_ = _expr_index;
			_expr_index = _tmp5_ + 1;
			_tmp6_ = _expr_index;
			_tmp7_ = _expr_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _expr_list;
			_tmp9_ = _expr_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			expr = (ValaExpression*) _tmp10_;
			_tmp11_ = expr;
			vala_code_node_accept ((ValaCodeNode*) _tmp11_, visitor);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
}


static void
vala_initializer_list_real_accept (ValaCodeNode* base,
                                   ValaCodeVisitor* visitor)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (visitor != NULL);
	vala_code_visitor_visit_initializer_list (visitor, self);
	vala_code_visitor_visit_expression (visitor, (ValaExpression*) self);
}


static gboolean
vala_initializer_list_real_is_constant (ValaExpression* base)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaExpression* initializer = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaExpression* _tmp11_;
			_tmp5_ = _initializer_index;
			_initializer_index = _tmp5_ + 1;
			_tmp6_ = _initializer_index;
			_tmp7_ = _initializer_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _initializer_list;
			_tmp9_ = _initializer_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			initializer = (ValaExpression*) _tmp10_;
			_tmp11_ = initializer;
			if (!vala_expression_is_constant (_tmp11_)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}


static gboolean
vala_initializer_list_real_is_pure (ValaExpression* base)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaExpression* initializer = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaExpression* _tmp11_;
			_tmp5_ = _initializer_index;
			_initializer_index = _tmp5_ + 1;
			_tmp6_ = _initializer_index;
			_tmp7_ = _initializer_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _initializer_list;
			_tmp9_ = _initializer_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			initializer = (ValaExpression*) _tmp10_;
			_tmp11_ = initializer;
			if (!vala_expression_is_pure (_tmp11_)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}


static gboolean
vala_initializer_list_real_is_accessible (ValaExpression* base,
                                          ValaSymbol* sym)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	self = (ValaInitializerList*) base;
	g_return_val_if_fail (sym != NULL, FALSE);
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _initializer_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _initializer_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_initializer_list = _tmp1_;
		_tmp2_ = _initializer_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_initializer_size = _tmp4_;
		_initializer_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaExpression* initializer = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaExpression* _tmp11_;
			_tmp5_ = _initializer_index;
			_initializer_index = _tmp5_ + 1;
			_tmp6_ = _initializer_index;
			_tmp7_ = _initializer_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _initializer_list;
			_tmp9_ = _initializer_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			initializer = (ValaExpression*) _tmp10_;
			_tmp11_ = initializer;
			if (!vala_expression_is_accessible (_tmp11_, sym)) {
				result = FALSE;
				_vala_code_node_unref0 (initializer);
				_vala_iterable_unref0 (_initializer_list);
				return result;
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = TRUE;
	return result;
}


static gchar*
vala_initializer_list_real_to_string (ValaCodeNode* base)
{
	ValaInitializerList * self;
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	gboolean first = FALSE;
	GString* _tmp21_;
	GString* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	self = (ValaInitializerList*) base;
	_tmp0_ = g_string_new ("{");
	builder = _tmp0_;
	first = TRUE;
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp1_;
		ValaList* _tmp2_;
		gint _initializer_size = 0;
		ValaList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _initializer_index = 0;
		_tmp1_ = self->priv->initializers;
		_tmp2_ = _vala_iterable_ref0 (_tmp1_);
		_initializer_list = _tmp2_;
		_tmp3_ = _initializer_list;
		_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_initializer_size = _tmp5_;
		_initializer_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			ValaExpression* initializer = NULL;
			ValaList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gboolean _tmp12_;
			_tmp6_ = _initializer_index;
			_initializer_index = _tmp6_ + 1;
			_tmp7_ = _initializer_index;
			_tmp8_ = _initializer_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _initializer_list;
			_tmp10_ = _initializer_index;
			_tmp11_ = vala_list_get (_tmp9_, _tmp10_);
			initializer = (ValaExpression*) _tmp11_;
			_tmp12_ = first;
			if (_tmp12_) {
				GString* _tmp13_;
				ValaExpression* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp13_ = builder;
				_tmp14_ = initializer;
				_tmp15_ = vala_code_node_to_string ((ValaCodeNode*) _tmp14_);
				_tmp16_ = _tmp15_;
				g_string_append (_tmp13_, _tmp16_);
				_g_free0 (_tmp16_);
				first = FALSE;
			} else {
				GString* _tmp17_;
				ValaExpression* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				_tmp17_ = builder;
				_tmp18_ = initializer;
				_tmp19_ = vala_code_node_to_string ((ValaCodeNode*) _tmp18_);
				_tmp20_ = _tmp19_;
				g_string_append_printf (_tmp17_, ", %s", _tmp20_);
				_g_free0 (_tmp20_);
			}
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	_tmp21_ = builder;
	g_string_append_c (_tmp21_, '}');
	_tmp22_ = builder;
	_tmp23_ = _tmp22_->str;
	_tmp24_ = g_strdup (_tmp23_);
	result = _tmp24_;
	_g_string_free0 (builder);
	return result;
}


static void
vala_initializer_list_real_replace_expression (ValaCodeNode* base,
                                               ValaExpression* old_node,
                                               ValaExpression* new_node)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (old_node != NULL);
	g_return_if_fail (new_node != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ValaList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				ValaList* _tmp6_;
				gint _tmp7_;
				gpointer _tmp8_;
				ValaExpression* _tmp9_;
				gboolean _tmp10_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				_tmp3_ = self->priv->initializers;
				_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
				_tmp5_ = _tmp4_;
				if (!(_tmp2_ < _tmp5_)) {
					break;
				}
				_tmp6_ = self->priv->initializers;
				_tmp7_ = i;
				_tmp8_ = vala_list_get (_tmp6_, _tmp7_);
				_tmp9_ = (ValaExpression*) _tmp8_;
				_tmp10_ = _tmp9_ == old_node;
				_vala_code_node_unref0 (_tmp9_);
				if (_tmp10_) {
					ValaList* _tmp11_;
					gint _tmp12_;
					_tmp11_ = self->priv->initializers;
					_tmp12_ = i;
					vala_list_set (_tmp11_, _tmp12_, new_node);
					vala_code_node_set_parent_node ((ValaCodeNode*) new_node, (ValaCodeNode*) self);
				}
			}
		}
	}
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


static gboolean
vala_initializer_list_real_check (ValaCodeNode* base,
                                  ValaCodeContext* context)
{
	ValaInitializerList * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValaDataType* _tmp4_;
	ValaDataType* _tmp5_;
	gboolean _error_ = FALSE;
	gboolean _tmp256_;
	gboolean _tmp263_;
	self = (ValaInitializerList*) base;
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = vala_code_node_get_checked ((ValaCodeNode*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = vala_code_node_get_error ((ValaCodeNode*) self);
		_tmp3_ = _tmp2_;
		result = !_tmp3_;
		return result;
	}
	vala_code_node_set_checked ((ValaCodeNode*) self, TRUE);
	_tmp4_ = vala_expression_get_target_type ((ValaExpression*) self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NULL) {
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
		_tmp6_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
		_tmp7_ = _tmp6_;
		vala_report_error (_tmp7_, "initializer list used for unknown type");
		result = FALSE;
		return result;
	} else {
		ValaDataType* _tmp8_;
		ValaDataType* _tmp9_;
		_tmp8_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp9_ = _tmp8_;
		if (VALA_IS_ARRAY_TYPE (_tmp9_)) {
			ValaArrayType* array_type = NULL;
			ValaDataType* _tmp10_;
			ValaDataType* _tmp11_;
			ValaArrayType* _tmp12_;
			gboolean requires_constants_only = FALSE;
			ValaCodeNode* node = NULL;
			ValaCodeNode* _tmp13_;
			ValaCodeNode* _tmp14_;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			ValaCodeNode* _tmp22_;
			ValaCodeNode* _tmp23_;
			ValaDataType* inner_target_type = NULL;
			ValaArrayType* _tmp58_;
			gint _tmp59_;
			gint _tmp60_;
			_tmp10_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp11_ = _tmp10_;
			_tmp12_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
			array_type = _tmp12_;
			requires_constants_only = FALSE;
			_tmp13_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp14_ = _tmp13_;
			node = _tmp14_;
			while (TRUE) {
				ValaCodeNode* _tmp15_;
				ValaCodeNode* _tmp16_;
				ValaCodeNode* _tmp17_;
				ValaCodeNode* _tmp18_;
				ValaCodeNode* _tmp19_;
				_tmp15_ = node;
				if (!(_tmp15_ != NULL)) {
					break;
				}
				_tmp16_ = node;
				if (VALA_IS_CONSTANT (_tmp16_)) {
					requires_constants_only = TRUE;
					break;
				}
				_tmp17_ = node;
				_tmp18_ = vala_code_node_get_parent_node (_tmp17_);
				_tmp19_ = _tmp18_;
				node = _tmp19_;
			}
			_tmp22_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
			_tmp23_ = _tmp22_;
			if (!VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp23_)) {
				gboolean _tmp24_;
				_tmp24_ = requires_constants_only;
				_tmp21_ = !_tmp24_;
			} else {
				_tmp21_ = FALSE;
			}
			if (_tmp21_) {
				gboolean _tmp25_ = FALSE;
				ValaCodeNode* _tmp26_;
				ValaCodeNode* _tmp27_;
				_tmp26_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp27_ = _tmp26_;
				if (!VALA_IS_INITIALIZER_LIST (_tmp27_)) {
					_tmp25_ = TRUE;
				} else {
					ValaCodeNode* _tmp28_;
					ValaCodeNode* _tmp29_;
					ValaDataType* _tmp30_;
					ValaDataType* _tmp31_;
					ValaTypeSymbol* _tmp32_;
					ValaTypeSymbol* _tmp33_;
					_tmp28_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp29_ = _tmp28_;
					_tmp30_ = vala_expression_get_target_type ((ValaExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList));
					_tmp31_ = _tmp30_;
					_tmp32_ = vala_data_type_get_data_type (_tmp31_);
					_tmp33_ = _tmp32_;
					_tmp25_ = VALA_IS_STRUCT (_tmp33_);
				}
				_tmp20_ = _tmp25_;
			} else {
				_tmp20_ = FALSE;
			}
			if (_tmp20_) {
				ValaCodeNode* old_parent_node = NULL;
				ValaCodeNode* _tmp34_;
				ValaCodeNode* _tmp35_;
				ValaCodeNode* _tmp36_;
				ValaArrayCreationExpression* array_creation = NULL;
				ValaArrayType* _tmp37_;
				ValaDataType* _tmp38_;
				ValaDataType* _tmp39_;
				ValaDataType* _tmp40_;
				ValaDataType* _tmp41_;
				ValaArrayType* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				ValaSourceReference* _tmp45_;
				ValaSourceReference* _tmp46_;
				ValaArrayCreationExpression* _tmp47_;
				ValaArrayCreationExpression* _tmp48_;
				ValaArrayCreationExpression* _tmp49_;
				ValaDataType* _tmp50_;
				ValaDataType* _tmp51_;
				ValaArrayCreationExpression* _tmp52_;
				ValaDataType* _tmp53_;
				ValaDataType* _tmp54_;
				ValaCodeNode* _tmp55_;
				ValaArrayCreationExpression* _tmp56_;
				ValaArrayCreationExpression* _tmp57_;
				_tmp34_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp35_ = _tmp34_;
				_tmp36_ = _vala_code_node_ref0 (_tmp35_);
				old_parent_node = _tmp36_;
				_tmp37_ = array_type;
				_tmp38_ = vala_array_type_get_element_type (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = vala_data_type_copy (_tmp39_);
				_tmp41_ = _tmp40_;
				_tmp42_ = array_type;
				_tmp43_ = vala_array_type_get_rank (_tmp42_);
				_tmp44_ = _tmp43_;
				_tmp45_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp46_ = _tmp45_;
				_tmp47_ = vala_array_creation_expression_new (_tmp41_, _tmp44_, self, _tmp46_);
				_tmp48_ = _tmp47_;
				_vala_code_node_unref0 (_tmp41_);
				array_creation = _tmp48_;
				_tmp49_ = array_creation;
				_tmp50_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp51_ = _tmp50_;
				vala_expression_set_target_type ((ValaExpression*) _tmp49_, _tmp51_);
				_tmp52_ = array_creation;
				_tmp53_ = vala_expression_get_formal_target_type ((ValaExpression*) self);
				_tmp54_ = _tmp53_;
				vala_expression_set_formal_target_type ((ValaExpression*) _tmp52_, _tmp54_);
				_tmp55_ = old_parent_node;
				_tmp56_ = array_creation;
				vala_code_node_replace_expression (_tmp55_, (ValaExpression*) self, (ValaExpression*) _tmp56_);
				vala_code_node_set_checked ((ValaCodeNode*) self, FALSE);
				_tmp57_ = array_creation;
				result = vala_code_node_check ((ValaCodeNode*) _tmp57_, context);
				_vala_code_node_unref0 (array_creation);
				_vala_code_node_unref0 (old_parent_node);
				_vala_code_node_unref0 (array_type);
				return result;
			}
			_tmp58_ = array_type;
			_tmp59_ = vala_array_type_get_rank (_tmp58_);
			_tmp60_ = _tmp59_;
			if (_tmp60_ > 1) {
				ValaArrayType* inner_array_type = NULL;
				ValaArrayType* _tmp61_;
				ValaDataType* _tmp62_;
				ValaArrayType* _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
				ValaArrayType* _tmp66_;
				ValaDataType* _tmp67_;
				_tmp61_ = array_type;
				_tmp62_ = vala_data_type_copy ((ValaDataType*) _tmp61_);
				inner_array_type = G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_ARRAY_TYPE, ValaArrayType);
				_tmp63_ = inner_array_type;
				_tmp64_ = vala_array_type_get_rank (_tmp63_);
				_tmp65_ = _tmp64_;
				vala_array_type_set_rank (_tmp63_, _tmp65_ - 1);
				_tmp66_ = inner_array_type;
				_tmp67_ = _vala_code_node_ref0 ((ValaDataType*) _tmp66_);
				_vala_code_node_unref0 (inner_target_type);
				inner_target_type = _tmp67_;
				_vala_code_node_unref0 (inner_array_type);
			} else {
				ValaArrayType* _tmp68_;
				ValaDataType* _tmp69_;
				ValaDataType* _tmp70_;
				ValaDataType* _tmp71_;
				_tmp68_ = array_type;
				_tmp69_ = vala_array_type_get_element_type (_tmp68_);
				_tmp70_ = _tmp69_;
				_tmp71_ = vala_data_type_copy (_tmp70_);
				_vala_code_node_unref0 (inner_target_type);
				inner_target_type = _tmp71_;
			}
			{
				ValaList* _e_list = NULL;
				ValaList* _tmp72_;
				gint _e_size = 0;
				ValaList* _tmp73_;
				gint _tmp74_;
				gint _tmp75_;
				gint _e_index = 0;
				_tmp72_ = vala_initializer_list_get_initializers (self);
				_e_list = _tmp72_;
				_tmp73_ = _e_list;
				_tmp74_ = vala_collection_get_size ((ValaCollection*) _tmp73_);
				_tmp75_ = _tmp74_;
				_e_size = _tmp75_;
				_e_index = -1;
				while (TRUE) {
					gint _tmp76_;
					gint _tmp77_;
					gint _tmp78_;
					ValaExpression* e = NULL;
					ValaList* _tmp79_;
					gint _tmp80_;
					gpointer _tmp81_;
					ValaExpression* _tmp82_;
					ValaDataType* _tmp83_;
					_tmp76_ = _e_index;
					_e_index = _tmp76_ + 1;
					_tmp77_ = _e_index;
					_tmp78_ = _e_size;
					if (!(_tmp77_ < _tmp78_)) {
						break;
					}
					_tmp79_ = _e_list;
					_tmp80_ = _e_index;
					_tmp81_ = vala_list_get (_tmp79_, _tmp80_);
					e = (ValaExpression*) _tmp81_;
					_tmp82_ = e;
					_tmp83_ = inner_target_type;
					vala_expression_set_target_type (_tmp82_, _tmp83_);
					_vala_code_node_unref0 (e);
				}
				_vala_iterable_unref0 (_e_list);
			}
			_vala_code_node_unref0 (inner_target_type);
			_vala_code_node_unref0 (array_type);
		} else {
			ValaDataType* _tmp84_;
			ValaDataType* _tmp85_;
			ValaTypeSymbol* _tmp86_;
			ValaTypeSymbol* _tmp87_;
			_tmp84_ = vala_expression_get_target_type ((ValaExpression*) self);
			_tmp85_ = _tmp84_;
			_tmp86_ = vala_data_type_get_data_type (_tmp85_);
			_tmp87_ = _tmp86_;
			if (VALA_IS_STRUCT (_tmp87_)) {
				ValaStruct* st = NULL;
				ValaDataType* _tmp88_;
				ValaDataType* _tmp89_;
				ValaTypeSymbol* _tmp90_;
				ValaTypeSymbol* _tmp91_;
				ValaStruct* _tmp92_;
				gboolean _tmp100_ = FALSE;
				ValaCodeNode* _tmp101_;
				ValaCodeNode* _tmp102_;
				gboolean in_array_creation_initializer = FALSE;
				ValaObjectCreationExpression* struct_creation = NULL;
				gboolean _tmp107_;
				ValaIterator* field_it = NULL;
				ValaStruct* _tmp127_;
				ValaList* _tmp128_;
				ValaList* _tmp129_;
				ValaIterator* _tmp130_;
				ValaIterator* _tmp131_;
				gboolean _tmp182_;
				_tmp88_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp89_ = _tmp88_;
				_tmp90_ = vala_data_type_get_data_type (_tmp89_);
				_tmp91_ = _tmp90_;
				_tmp92_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, VALA_TYPE_STRUCT, ValaStruct));
				st = _tmp92_;
				while (TRUE) {
					ValaStruct* _tmp93_;
					ValaStruct* _tmp94_;
					ValaStruct* _tmp95_;
					ValaStruct* _tmp96_;
					ValaStruct* _tmp97_;
					ValaStruct* _tmp98_;
					ValaStruct* _tmp99_;
					_tmp93_ = st;
					_tmp94_ = vala_struct_get_base_struct (_tmp93_);
					_tmp95_ = _tmp94_;
					if (!(_tmp95_ != NULL)) {
						break;
					}
					_tmp96_ = st;
					_tmp97_ = vala_struct_get_base_struct (_tmp96_);
					_tmp98_ = _tmp97_;
					_tmp99_ = _vala_code_node_ref0 (_tmp98_);
					_vala_code_node_unref0 (st);
					st = _tmp99_;
				}
				_tmp101_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
				_tmp102_ = _tmp101_;
				if (VALA_IS_INITIALIZER_LIST (_tmp102_)) {
					ValaCodeNode* _tmp103_;
					ValaCodeNode* _tmp104_;
					ValaCodeNode* _tmp105_;
					ValaCodeNode* _tmp106_;
					_tmp103_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp104_ = _tmp103_;
					_tmp105_ = vala_code_node_get_parent_node (_tmp104_);
					_tmp106_ = _tmp105_;
					_tmp100_ = VALA_IS_ARRAY_CREATION_EXPRESSION (_tmp106_);
				} else {
					_tmp100_ = FALSE;
				}
				in_array_creation_initializer = _tmp100_;
				struct_creation = NULL;
				_tmp107_ = in_array_creation_initializer;
				if (_tmp107_) {
					ValaMemberAccess* ma = NULL;
					ValaStruct* _tmp108_;
					const gchar* _tmp109_;
					const gchar* _tmp110_;
					ValaSourceReference* _tmp111_;
					ValaSourceReference* _tmp112_;
					ValaMemberAccess* _tmp113_;
					ValaMemberAccess* _tmp114_;
					ValaMemberAccess* _tmp115_;
					ValaStruct* _tmp116_;
					ValaMemberAccess* _tmp117_;
					ValaSourceReference* _tmp118_;
					ValaSourceReference* _tmp119_;
					ValaObjectCreationExpression* _tmp120_;
					ValaObjectCreationExpression* _tmp121_;
					ValaDataType* _tmp122_;
					ValaDataType* _tmp123_;
					ValaDataType* _tmp124_;
					ValaDataType* _tmp125_;
					ValaObjectCreationExpression* _tmp126_;
					_tmp108_ = st;
					_tmp109_ = vala_symbol_get_name ((ValaSymbol*) _tmp108_);
					_tmp110_ = _tmp109_;
					_tmp111_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp112_ = _tmp111_;
					_tmp113_ = vala_member_access_new_simple (_tmp110_, _tmp112_);
					ma = _tmp113_;
					_tmp114_ = ma;
					vala_member_access_set_creation_member (_tmp114_, TRUE);
					_tmp115_ = ma;
					_tmp116_ = st;
					vala_expression_set_symbol_reference ((ValaExpression*) _tmp115_, (ValaSymbol*) _tmp116_);
					_tmp117_ = ma;
					_tmp118_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
					_tmp119_ = _tmp118_;
					_tmp120_ = vala_object_creation_expression_new (_tmp117_, _tmp119_);
					_vala_code_node_unref0 (struct_creation);
					struct_creation = _tmp120_;
					_tmp121_ = struct_creation;
					_tmp122_ = vala_expression_get_target_type ((ValaExpression*) self);
					_tmp123_ = _tmp122_;
					_tmp124_ = vala_data_type_copy (_tmp123_);
					_tmp125_ = _tmp124_;
					vala_expression_set_target_type ((ValaExpression*) _tmp121_, _tmp125_);
					_vala_code_node_unref0 (_tmp125_);
					_tmp126_ = struct_creation;
					vala_object_creation_expression_set_struct_creation (_tmp126_, TRUE);
					_vala_code_node_unref0 (ma);
				}
				_tmp127_ = st;
				_tmp128_ = vala_struct_get_fields (_tmp127_);
				_tmp129_ = _tmp128_;
				_tmp130_ = vala_iterable_iterator ((ValaIterable*) _tmp129_);
				_tmp131_ = _tmp130_;
				_vala_iterable_unref0 (_tmp129_);
				field_it = _tmp131_;
				{
					ValaList* _e_list = NULL;
					ValaList* _tmp132_;
					gint _e_size = 0;
					ValaList* _tmp133_;
					gint _tmp134_;
					gint _tmp135_;
					gint _e_index = 0;
					_tmp132_ = vala_initializer_list_get_initializers (self);
					_e_list = _tmp132_;
					_tmp133_ = _e_list;
					_tmp134_ = vala_collection_get_size ((ValaCollection*) _tmp133_);
					_tmp135_ = _tmp134_;
					_e_size = _tmp135_;
					_e_index = -1;
					while (TRUE) {
						gint _tmp136_;
						gint _tmp137_;
						gint _tmp138_;
						ValaExpression* e = NULL;
						ValaList* _tmp139_;
						gint _tmp140_;
						gpointer _tmp141_;
						ValaField* field = NULL;
						gboolean _tmp158_;
						_tmp136_ = _e_index;
						_e_index = _tmp136_ + 1;
						_tmp137_ = _e_index;
						_tmp138_ = _e_size;
						if (!(_tmp137_ < _tmp138_)) {
							break;
						}
						_tmp139_ = _e_list;
						_tmp140_ = _e_index;
						_tmp141_ = vala_list_get (_tmp139_, _tmp140_);
						e = (ValaExpression*) _tmp141_;
						field = NULL;
						while (TRUE) {
							ValaField* _tmp142_;
							ValaIterator* _tmp143_;
							ValaIterator* _tmp153_;
							gpointer _tmp154_;
							ValaField* _tmp155_;
							ValaMemberBinding _tmp156_;
							ValaMemberBinding _tmp157_;
							_tmp142_ = field;
							if (!(_tmp142_ == NULL)) {
								break;
							}
							_tmp143_ = field_it;
							if (!vala_iterator_next (_tmp143_)) {
								ValaExpression* _tmp144_;
								ValaSourceReference* _tmp145_;
								ValaSourceReference* _tmp146_;
								ValaDataType* _tmp147_;
								ValaDataType* _tmp148_;
								gchar* _tmp149_;
								gchar* _tmp150_;
								gchar* _tmp151_;
								gchar* _tmp152_;
								vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
								_tmp144_ = e;
								_tmp145_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp144_);
								_tmp146_ = _tmp145_;
								_tmp147_ = vala_expression_get_target_type ((ValaExpression*) self);
								_tmp148_ = _tmp147_;
								_tmp149_ = vala_code_node_to_string ((ValaCodeNode*) _tmp148_);
								_tmp150_ = _tmp149_;
								_tmp151_ = g_strdup_printf ("too many expressions in initializer list for `%s'", _tmp150_);
								_tmp152_ = _tmp151_;
								vala_report_error (_tmp146_, _tmp152_);
								_g_free0 (_tmp152_);
								_g_free0 (_tmp150_);
								result = FALSE;
								_vala_code_node_unref0 (field);
								_vala_code_node_unref0 (e);
								_vala_iterable_unref0 (_e_list);
								_vala_iterator_unref0 (field_it);
								_vala_code_node_unref0 (struct_creation);
								_vala_code_node_unref0 (st);
								return result;
							}
							_tmp153_ = field_it;
							_tmp154_ = vala_iterator_get (_tmp153_);
							_vala_code_node_unref0 (field);
							field = (ValaField*) _tmp154_;
							_tmp155_ = field;
							_tmp156_ = vala_field_get_binding (_tmp155_);
							_tmp157_ = _tmp156_;
							if (_tmp157_ != VALA_MEMBER_BINDING_INSTANCE) {
								_vala_code_node_unref0 (field);
								field = NULL;
							}
						}
						_tmp158_ = in_array_creation_initializer;
						if (_tmp158_) {
							ValaMemberInitializer* member_init = NULL;
							ValaField* _tmp159_;
							const gchar* _tmp160_;
							const gchar* _tmp161_;
							ValaExpression* _tmp162_;
							ValaExpression* _tmp163_;
							ValaSourceReference* _tmp164_;
							ValaSourceReference* _tmp165_;
							ValaMemberInitializer* _tmp166_;
							ValaObjectCreationExpression* _tmp167_;
							ValaMemberInitializer* _tmp168_;
							_tmp159_ = field;
							_tmp160_ = vala_symbol_get_name ((ValaSymbol*) _tmp159_);
							_tmp161_ = _tmp160_;
							_tmp162_ = e;
							_tmp163_ = e;
							_tmp164_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp163_);
							_tmp165_ = _tmp164_;
							_tmp166_ = vala_member_initializer_new (_tmp161_, _tmp162_, _tmp165_);
							member_init = _tmp166_;
							_tmp167_ = struct_creation;
							_tmp168_ = member_init;
							vala_object_creation_expression_add_member_initializer (_tmp167_, _tmp168_);
							_vala_code_node_unref0 (member_init);
						} else {
							ValaExpression* _tmp169_;
							ValaField* _tmp170_;
							ValaDataType* _tmp171_;
							ValaDataType* _tmp172_;
							ValaDataType* _tmp173_;
							ValaDataType* _tmp174_;
							ValaDataType* _tmp175_;
							ValaDataType* _tmp176_;
							gboolean _tmp177_;
							gboolean _tmp178_;
							_tmp169_ = e;
							_tmp170_ = field;
							_tmp171_ = vala_variable_get_variable_type ((ValaVariable*) _tmp170_);
							_tmp172_ = _tmp171_;
							_tmp173_ = vala_data_type_copy (_tmp172_);
							_tmp174_ = _tmp173_;
							vala_expression_set_target_type (_tmp169_, _tmp174_);
							_vala_code_node_unref0 (_tmp174_);
							_tmp175_ = vala_expression_get_target_type ((ValaExpression*) self);
							_tmp176_ = _tmp175_;
							_tmp177_ = vala_data_type_get_value_owned (_tmp176_);
							_tmp178_ = _tmp177_;
							if (!_tmp178_) {
								ValaExpression* _tmp179_;
								ValaDataType* _tmp180_;
								ValaDataType* _tmp181_;
								_tmp179_ = e;
								_tmp180_ = vala_expression_get_target_type (_tmp179_);
								_tmp181_ = _tmp180_;
								vala_data_type_set_value_owned (_tmp181_, FALSE);
							}
						}
						_vala_code_node_unref0 (field);
						_vala_code_node_unref0 (e);
					}
					_vala_iterable_unref0 (_e_list);
				}
				_tmp182_ = in_array_creation_initializer;
				if (_tmp182_) {
					ValaCodeNode* _tmp183_;
					ValaCodeNode* _tmp184_;
					ValaObjectCreationExpression* _tmp185_;
					ValaObjectCreationExpression* _tmp186_;
					_tmp183_ = vala_code_node_get_parent_node ((ValaCodeNode*) self);
					_tmp184_ = _tmp183_;
					_tmp185_ = struct_creation;
					vala_code_node_replace_expression (_tmp184_, (ValaExpression*) self, (ValaExpression*) _tmp185_);
					vala_code_node_set_checked ((ValaCodeNode*) self, FALSE);
					_tmp186_ = struct_creation;
					result = vala_code_node_check ((ValaCodeNode*) _tmp186_, context);
					_vala_iterator_unref0 (field_it);
					_vala_code_node_unref0 (struct_creation);
					_vala_code_node_unref0 (st);
					return result;
				}
				_vala_iterator_unref0 (field_it);
				_vala_code_node_unref0 (struct_creation);
				_vala_code_node_unref0 (st);
			} else {
				ValaSourceReference* _tmp187_;
				ValaSourceReference* _tmp188_;
				ValaDataType* _tmp189_;
				ValaDataType* _tmp190_;
				gchar* _tmp191_;
				gchar* _tmp192_;
				gchar* _tmp193_;
				gchar* _tmp194_;
				vala_code_node_set_error ((ValaCodeNode*) self, TRUE);
				_tmp187_ = vala_code_node_get_source_reference ((ValaCodeNode*) self);
				_tmp188_ = _tmp187_;
				_tmp189_ = vala_expression_get_target_type ((ValaExpression*) self);
				_tmp190_ = _tmp189_;
				_tmp191_ = vala_code_node_to_string ((ValaCodeNode*) _tmp190_);
				_tmp192_ = _tmp191_;
				_tmp193_ = g_strdup_printf ("initializer list used for `%s', which is neither array nor struct", _tmp192_);
				_tmp194_ = _tmp193_;
				vala_report_error (_tmp188_, _tmp194_);
				_g_free0 (_tmp194_);
				_g_free0 (_tmp192_);
				result = FALSE;
				return result;
			}
		}
	}
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp195_;
		ValaList* _tmp196_;
		gint _expr_size = 0;
		ValaList* _tmp197_;
		gint _tmp198_;
		gint _tmp199_;
		gint _expr_index = 0;
		_tmp195_ = self->priv->initializers;
		_tmp196_ = _vala_iterable_ref0 (_tmp195_);
		_expr_list = _tmp196_;
		_tmp197_ = _expr_list;
		_tmp198_ = vala_collection_get_size ((ValaCollection*) _tmp197_);
		_tmp199_ = _tmp198_;
		_expr_size = _tmp199_;
		_expr_index = -1;
		while (TRUE) {
			gint _tmp200_;
			gint _tmp201_;
			gint _tmp202_;
			ValaExpression* expr = NULL;
			ValaList* _tmp203_;
			gint _tmp204_;
			gpointer _tmp205_;
			ValaExpression* _tmp206_;
			_tmp200_ = _expr_index;
			_expr_index = _tmp200_ + 1;
			_tmp201_ = _expr_index;
			_tmp202_ = _expr_size;
			if (!(_tmp201_ < _tmp202_)) {
				break;
			}
			_tmp203_ = _expr_list;
			_tmp204_ = _expr_index;
			_tmp205_ = vala_list_get (_tmp203_, _tmp204_);
			expr = (ValaExpression*) _tmp205_;
			_tmp206_ = expr;
			vala_code_node_check ((ValaCodeNode*) _tmp206_, context);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
	_error_ = FALSE;
	{
		ValaList* _e_list = NULL;
		ValaList* _tmp207_;
		gint _e_size = 0;
		ValaList* _tmp208_;
		gint _tmp209_;
		gint _tmp210_;
		gint _e_index = 0;
		_tmp207_ = vala_initializer_list_get_initializers (self);
		_e_list = _tmp207_;
		_tmp208_ = _e_list;
		_tmp209_ = vala_collection_get_size ((ValaCollection*) _tmp208_);
		_tmp210_ = _tmp209_;
		_e_size = _tmp210_;
		_e_index = -1;
		while (TRUE) {
			gint _tmp211_;
			gint _tmp212_;
			gint _tmp213_;
			ValaExpression* e = NULL;
			ValaList* _tmp214_;
			gint _tmp215_;
			gpointer _tmp216_;
			ValaExpression* _tmp217_;
			ValaDataType* _tmp218_;
			ValaDataType* _tmp219_;
			ValaUnaryExpression* unary = NULL;
			ValaExpression* _tmp223_;
			ValaUnaryExpression* _tmp224_;
			gboolean _tmp225_ = FALSE;
			ValaUnaryExpression* _tmp226_;
			_tmp211_ = _e_index;
			_e_index = _tmp211_ + 1;
			_tmp212_ = _e_index;
			_tmp213_ = _e_size;
			if (!(_tmp212_ < _tmp213_)) {
				break;
			}
			_tmp214_ = _e_list;
			_tmp215_ = _e_index;
			_tmp216_ = vala_list_get (_tmp214_, _tmp215_);
			e = (ValaExpression*) _tmp216_;
			_tmp217_ = e;
			_tmp218_ = vala_expression_get_value_type (_tmp217_);
			_tmp219_ = _tmp218_;
			if (_tmp219_ == NULL) {
				ValaExpression* _tmp220_;
				ValaSourceReference* _tmp221_;
				ValaSourceReference* _tmp222_;
				_error_ = TRUE;
				_tmp220_ = e;
				_tmp221_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp220_);
				_tmp222_ = _tmp221_;
				vala_report_error (_tmp222_, "expression type not allowed as initializer");
				_vala_code_node_unref0 (e);
				continue;
			}
			_tmp223_ = e;
			_tmp224_ = _vala_code_node_ref0 (VALA_IS_UNARY_EXPRESSION (_tmp223_) ? ((ValaUnaryExpression*) _tmp223_) : NULL);
			unary = _tmp224_;
			_tmp226_ = unary;
			if (_tmp226_ != NULL) {
				gboolean _tmp227_ = FALSE;
				ValaUnaryExpression* _tmp228_;
				ValaUnaryOperator _tmp229_;
				ValaUnaryOperator _tmp230_;
				_tmp228_ = unary;
				_tmp229_ = vala_unary_expression_get_operator (_tmp228_);
				_tmp230_ = _tmp229_;
				if (_tmp230_ == VALA_UNARY_OPERATOR_REF) {
					_tmp227_ = TRUE;
				} else {
					ValaUnaryExpression* _tmp231_;
					ValaUnaryOperator _tmp232_;
					ValaUnaryOperator _tmp233_;
					_tmp231_ = unary;
					_tmp232_ = vala_unary_expression_get_operator (_tmp231_);
					_tmp233_ = _tmp232_;
					_tmp227_ = _tmp233_ == VALA_UNARY_OPERATOR_OUT;
				}
				_tmp225_ = _tmp227_;
			} else {
				_tmp225_ = FALSE;
			}
			if (_tmp225_) {
			} else {
				ValaExpression* _tmp234_;
				ValaDataType* _tmp235_;
				ValaDataType* _tmp236_;
				ValaExpression* _tmp237_;
				ValaDataType* _tmp238_;
				ValaDataType* _tmp239_;
				_tmp234_ = e;
				_tmp235_ = vala_expression_get_value_type (_tmp234_);
				_tmp236_ = _tmp235_;
				_tmp237_ = e;
				_tmp238_ = vala_expression_get_target_type (_tmp237_);
				_tmp239_ = _tmp238_;
				if (!vala_data_type_compatible (_tmp236_, _tmp239_)) {
					ValaExpression* _tmp240_;
					ValaExpression* _tmp241_;
					ValaSourceReference* _tmp242_;
					ValaSourceReference* _tmp243_;
					ValaExpression* _tmp244_;
					ValaDataType* _tmp245_;
					ValaDataType* _tmp246_;
					gchar* _tmp247_;
					gchar* _tmp248_;
					ValaExpression* _tmp249_;
					ValaDataType* _tmp250_;
					ValaDataType* _tmp251_;
					gchar* _tmp252_;
					gchar* _tmp253_;
					gchar* _tmp254_;
					gchar* _tmp255_;
					_error_ = TRUE;
					_tmp240_ = e;
					vala_code_node_set_error ((ValaCodeNode*) _tmp240_, TRUE);
					_tmp241_ = e;
					_tmp242_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp241_);
					_tmp243_ = _tmp242_;
					_tmp244_ = e;
					_tmp245_ = vala_expression_get_target_type (_tmp244_);
					_tmp246_ = _tmp245_;
					_tmp247_ = vala_code_node_to_string ((ValaCodeNode*) _tmp246_);
					_tmp248_ = _tmp247_;
					_tmp249_ = e;
					_tmp250_ = vala_expression_get_value_type (_tmp249_);
					_tmp251_ = _tmp250_;
					_tmp252_ = vala_code_node_to_string ((ValaCodeNode*) _tmp251_);
					_tmp253_ = _tmp252_;
					_tmp254_ = g_strdup_printf ("Expected initializer of type `%s' but got `%s'", _tmp248_, _tmp253_);
					_tmp255_ = _tmp254_;
					vala_report_error (_tmp243_, _tmp255_);
					_g_free0 (_tmp255_);
					_g_free0 (_tmp253_);
					_g_free0 (_tmp248_);
				}
			}
			_vala_code_node_unref0 (unary);
			_vala_code_node_unref0 (e);
		}
		_vala_iterable_unref0 (_e_list);
	}
	_tmp256_ = _error_;
	if (!_tmp256_) {
		ValaDataType* _tmp257_;
		ValaDataType* _tmp258_;
		ValaDataType* _tmp259_;
		ValaDataType* _tmp260_;
		ValaDataType* _tmp261_;
		ValaDataType* _tmp262_;
		_tmp257_ = vala_expression_get_target_type ((ValaExpression*) self);
		_tmp258_ = _tmp257_;
		_tmp259_ = vala_data_type_copy (_tmp258_);
		_tmp260_ = _tmp259_;
		vala_expression_set_value_type ((ValaExpression*) self, _tmp260_);
		_vala_code_node_unref0 (_tmp260_);
		_tmp261_ = vala_expression_get_value_type ((ValaExpression*) self);
		_tmp262_ = _tmp261_;
		vala_data_type_set_nullable (_tmp262_, FALSE);
	}
	_tmp263_ = _error_;
	result = !_tmp263_;
	return result;
}


static void
vala_initializer_list_real_emit (ValaCodeNode* base,
                                 ValaCodeGenerator* codegen)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (codegen != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaExpression* expr = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaExpression* _tmp11_;
			_tmp5_ = _expr_index;
			_expr_index = _tmp5_ + 1;
			_tmp6_ = _expr_index;
			_tmp7_ = _expr_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _expr_list;
			_tmp9_ = _expr_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			expr = (ValaExpression*) _tmp10_;
			_tmp11_ = expr;
			vala_code_node_emit ((ValaCodeNode*) _tmp11_, codegen);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
	vala_code_visitor_visit_initializer_list ((ValaCodeVisitor*) codegen, self);
	vala_code_visitor_visit_expression ((ValaCodeVisitor*) codegen, (ValaExpression*) self);
}


static void
vala_initializer_list_real_get_used_variables (ValaCodeNode* base,
                                               ValaCollection* collection)
{
	ValaInitializerList * self;
	self = (ValaInitializerList*) base;
	g_return_if_fail (collection != NULL);
	{
		ValaList* _expr_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _expr_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _expr_index = 0;
		_tmp0_ = self->priv->initializers;
		_tmp1_ = _vala_iterable_ref0 (_tmp0_);
		_expr_list = _tmp1_;
		_tmp2_ = _expr_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_expr_size = _tmp4_;
		_expr_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ValaExpression* expr = NULL;
			ValaList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ValaExpression* _tmp11_;
			_tmp5_ = _expr_index;
			_expr_index = _tmp5_ + 1;
			_tmp6_ = _expr_index;
			_tmp7_ = _expr_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _expr_list;
			_tmp9_ = _expr_index;
			_tmp10_ = vala_list_get (_tmp8_, _tmp9_);
			expr = (ValaExpression*) _tmp10_;
			_tmp11_ = expr;
			vala_code_node_get_used_variables ((ValaCodeNode*) _tmp11_, collection);
			_vala_code_node_unref0 (expr);
		}
		_vala_iterable_unref0 (_expr_list);
	}
}


gint
vala_initializer_list_get_size (ValaInitializerList* self)
{
	gint result;
	ValaList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->initializers;
	_tmp1_ = vala_collection_get_size ((ValaCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void
vala_initializer_list_class_init (ValaInitializerListClass * klass)
{
	vala_initializer_list_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeNodeClass *) klass)->finalize = vala_initializer_list_finalize;
	g_type_class_add_private (klass, sizeof (ValaInitializerListPrivate));
	((ValaCodeNodeClass *) klass)->accept_children = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_initializer_list_real_accept_children;
	((ValaCodeNodeClass *) klass)->accept = (void (*) (ValaCodeNode*, ValaCodeVisitor*)) vala_initializer_list_real_accept;
	((ValaExpressionClass *) klass)->is_constant = (gboolean (*) (ValaExpression*)) vala_initializer_list_real_is_constant;
	((ValaExpressionClass *) klass)->is_pure = (gboolean (*) (ValaExpression*)) vala_initializer_list_real_is_pure;
	((ValaExpressionClass *) klass)->is_accessible = (gboolean (*) (ValaExpression*, ValaSymbol*)) vala_initializer_list_real_is_accessible;
	((ValaCodeNodeClass *) klass)->to_string = (gchar* (*) (ValaCodeNode*)) vala_initializer_list_real_to_string;
	((ValaCodeNodeClass *) klass)->replace_expression = (void (*) (ValaCodeNode*, ValaExpression*, ValaExpression*)) vala_initializer_list_real_replace_expression;
	((ValaCodeNodeClass *) klass)->check = (gboolean (*) (ValaCodeNode*, ValaCodeContext*)) vala_initializer_list_real_check;
	((ValaCodeNodeClass *) klass)->emit = (void (*) (ValaCodeNode*, ValaCodeGenerator*)) vala_initializer_list_real_emit;
	((ValaCodeNodeClass *) klass)->get_used_variables = (void (*) (ValaCodeNode*, ValaCollection*)) vala_initializer_list_real_get_used_variables;
}


static void
vala_initializer_list_instance_init (ValaInitializerList * self)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = VALA_INITIALIZER_LIST_GET_PRIVATE (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	self->priv->initializers = (ValaList*) _tmp1_;
}


static void
vala_initializer_list_finalize (ValaCodeNode * obj)
{
	ValaInitializerList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_INITIALIZER_LIST, ValaInitializerList);
	_vala_iterable_unref0 (self->priv->initializers);
	VALA_CODE_NODE_CLASS (vala_initializer_list_parent_class)->finalize (obj);
}


/**
 * Represents an array or struct initializer list in the source code.
 */
GType
vala_initializer_list_get_type (void)
{
	static volatile gsize vala_initializer_list_type_id__volatile = 0;
	if (g_once_init_enter (&vala_initializer_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaInitializerListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_initializer_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaInitializerList), 0, (GInstanceInitFunc) vala_initializer_list_instance_init, NULL };
		GType vala_initializer_list_type_id;
		vala_initializer_list_type_id = g_type_register_static (VALA_TYPE_EXPRESSION, "ValaInitializerList", &g_define_type_info, 0);
		g_once_init_leave (&vala_initializer_list_type_id__volatile, vala_initializer_list_type_id);
	}
	return vala_initializer_list_type_id__volatile;
}



